Attribute VB_Name = "Module1"
Option Explicit
Public Const PD_ALLPAGES = &H0&
Public Const PD_SELECTION = &H1&
Public Const PD_PAGENUMS = &H2&
Public Const PD_NOSELECTION = &H4&
Public Const PD_NOPAGENUMS = &H8&
Public Const PD_COLLATE = &H10&
Public Const PD_PRINTTOFILE = &H20&
Public Const PD_PRINTSETUP = &H40&
Public Const PD_NOWARNING = &H80&
Public Const PD_RETURNDC = &H100&
Public Const PD_RETURNIC = &H200&
Public Const PD_RETURNDEFAULT = &H400&
Public Const PD_SHOWHELP = &H800&
Public Const PD_USEDEVMODECOPIES = &H40000
Public Const PD_DISABLEPRINTTOFILE = &H80000
Public Const PD_HIDEPRINTTOFILE = &H100000




Private Function Nb_Jours_Ouvrables(Date_dbut As Date, Date_fin As Date) As Single

          Static Temp As Double
          'Les valeurs de date notes en dur dans le code doivent tre au format amricain
          'Fonction qui donne la dure en jours ouvrables entre deux dates
          'Test de validit des dates
          If IsNull(Date_dbut) Or IsNull(Date_fin) Then
              Nb_Jours_Ouvrables = 0
              Exit Function
          ElseIf Not IsDate(Date_dbut) Or Not IsDate(Date_fin) Then
              Nb_Jours_Ouvrables = 0
              Exit Function
          ElseIf Date_dbut > Date_fin Then
              Nb_Jours_Ouvrables = 0
              Exit Function
          End If
          'Convertion des dates en valeurs numriques (Double) format de date interne de la machine
          Dim dblDate_Dbut As Double
          Dim dblDate_Fin As Double
          dblDate_Dbut = CDbl(Date_dbut)
          dblDate_Fin = CDbl(Date_fin)
          Dim Date_Courante As Date
          Dim Var As Integer
          Do Until dblDate_Dbut > dblDate_Fin
              Date_Courante = CDate(dblDate_Dbut)
              'Test pour savoir si le jour courant est ouvrable
               If Weekday(Date_Courante) <> 1 And Weekday(Date_Courante) <> 7 Then
                  'Test des jours fris avec dates invariables
                  Select Case Date_Courante
                      Case CDate("01/01/" & Year(Date))   'Jour de l'an
                      Case CDate("01/05/" & Year(Date))   'Fte du travail
                      Case CDate("08/05/" & Year(Date))   'Armistice 1945
                      Case CDate("14/07/" & Year(Date))   'Fte nationale
                      Case CDate("15/08/" & Year(Date))   '15 Aout
                      Case CDate("01/11/" & Year(Date))   '1er Novembre
                      Case CDate("11/11/" & Year(Date))   'Armistice 1918
                      Case CDate("25/12/" & Year(Date))   'Jour de nol
                      Case Else
                      'Certains jours feri religieux ncessitent un traitement spciale
                      If Date_Catholique(Date_Courante) = False Then
                          Var = Var + 1
                      End If
                  End Select
              End If
              dblDate_Dbut = dblDate_Dbut + 1
          Loop
      Nb_Jours_Ouvrables = Var
End Function
Private Function Date_Catholique(LaDate As Date) As Boolean
'Cette fonction contrle si le jours n'est pas un jour feri catholique
'Toute les dates sont bases sur le Dimanche de paque
Dim Pques As Date
Pques = FetePaque(Year(LaDate))
    Select Case LaDate
    Case Pques + 1 'Lundi de Pques
    Date_Catholique = True
    Case Pques + 39 'jeudi de l'ascension
    Date_Catholique = True
    Case Pques + 50    'Lundi de la pentcte
    Date_Catholique = True
    Case Else
    Date_Catholique = False
    End Select
End Function
Function FetePaque(An As Integer) As Date
' Calcul du jour de la fte de Paques.
Dim A, b, C, D, e, F, g, h, i, k, l, m, n, p As Integer
A = Int(An Mod 19)
b = Int(An \ 100)
C = Int(An Mod 100)
D = b \ 4
e = b Mod 4
F = (b + 8) \ 25
g = (b - F + 1) \ 3
h = (19 * A + b - D - g + 15) Mod 30
i = C \ 4
k = C Mod 4
l = (32 + 2 * e + 2 * i - h - k) Mod 7
m = (A + 11 * h + 22 * l) \ 451
n = (h + l - 7 * m + 114) \ 31
p = (h + l - 7 * m + 114) Mod 31
FetePaque = DateSerial(An, n, p + 1)
End Function
Private Sub SetArrayFile(ByVal sPath As String, ByRef aLines() As String, Optional sRowsSepar As String = vbCrLf)
'enregistrer le tableau
    Dim FF As Integer
    FF = frmMain.MSFlexGrid1
    Open sPath For Output As #FF
        Print #FF, Join(aLines, sRowsSepar);
    Close #FF
End Sub
